<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosStkERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentosStkERP
 * @subpackage Arrays
 */
class ArrayOfDocumentosStkERP extends AbstractStructArrayBase
{
    /**
     * The DocumentosStkERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosStkERP[]
     */
    public $DocumentosStkERP;
    /**
     * Constructor method for ArrayOfDocumentosStkERP
     * @uses ArrayOfDocumentosStkERP::setDocumentosStkERP()
     * @param \StructType\DocumentosStkERP[] $documentosStkERP
     */
    public function __construct(array $documentosStkERP = array())
    {
        $this
            ->setDocumentosStkERP($documentosStkERP);
    }
    /**
     * Get DocumentosStkERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosStkERP[]|null
     */
    public function getDocumentosStkERP()
    {
        return isset($this->DocumentosStkERP) ? $this->DocumentosStkERP : null;
    }
    /**
     * Set DocumentosStkERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosStkERP[] $documentosStkERP
     * @return \ArrayType\ArrayOfDocumentosStkERP
     */
    public function setDocumentosStkERP(array $documentosStkERP = array())
    {
        foreach ($documentosStkERP as $arrayOfDocumentosStkERPDocumentosStkERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosStkERPDocumentosStkERPItem instanceof \StructType\DocumentosStkERP) {
                throw new \InvalidArgumentException(sprintf('The DocumentosStkERP property can only contain items of \StructType\DocumentosStkERP, "%s" given', is_object($arrayOfDocumentosStkERPDocumentosStkERPItem) ? get_class($arrayOfDocumentosStkERPDocumentosStkERPItem) : gettype($arrayOfDocumentosStkERPDocumentosStkERPItem)), __LINE__);
            }
        }
        if (is_null($documentosStkERP) || (is_array($documentosStkERP) && empty($documentosStkERP))) {
            unset($this->DocumentosStkERP);
        } else {
            $this->DocumentosStkERP = $documentosStkERP;
        }
        return $this;
    }
    /**
     * Add item to DocumentosStkERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosStkERP $item
     * @return \ArrayType\ArrayOfDocumentosStkERP
     */
    public function addToDocumentosStkERP(\StructType\DocumentosStkERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosStkERP) {
            throw new \InvalidArgumentException(sprintf('The DocumentosStkERP property can only contain items of \StructType\DocumentosStkERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosStkERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosStkERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosStkERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosStkERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosStkERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosStkERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosStkERP
     */
    public function getAttributeName()
    {
        return 'DocumentosStkERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosStkERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
